let start;

// btnPressed
const btnPressed = (button) => {
  if (typeof button == "object") {
    return button.pressed;
  }
  return button == 1.0;
};


// padMonitor
const padMonitor = () => {

  const gamepads = navigator.getGamepads
    ? navigator.getGamepads()
    : navigator.webkitGetGamepads
    ? navigator.webkitGetGamepads
    : [];
  if (!gamepads) {
    return;
  }

  const gp = gamepads[0];

  // A
  if (btnPressed(gp.buttons[0])) {
    $('#gamepad .btn_a').show();
  } else {
    $('#gamepad .btn_a').hide();
  }
  // Y
  if (btnPressed(gp.buttons[3])) {
    $('#gamepad .btn_y').show();
  } else {
    $('#gamepad .btn_y').hide();
  }
  // B
  if (btnPressed(gp.buttons[1])) {
    $('#gamepad .btn_b').show();
  } else {
    $('#gamepad .btn_b').hide();
  }
  // X
  if (btnPressed(gp.buttons[2])) {
    $('#gamepad .btn_x').show();
  } else {
    $('#gamepad .btn_x').hide();
  }

  // RB S
  if (btnPressed(gp.buttons[5])) {
    $('#gamepad .btn_rb').show();
  } else {
    $('#gamepad .btn_rb').hide();
  }

  // RT S
  if (btnPressed(gp.buttons[7])) {
    $('#gamepad .btn_rt').show();
  } else {
    $('#gamepad .btn_rt').hide();
  }


  // LB
  if (btnPressed(gp.buttons[4])) {
    $('#gamepad .btn_lb').show();
  } else {
    $('#gamepad .btn_lb').hide();
  }
  // LT
  if (btnPressed(gp.buttons[6])) {
    $('#gamepad .btn_lt').show();
  } else {
    $('#gamepad .btn_lt').hide();
  }

  // LSB
  if (btnPressed(gp.buttons[10])) {
    $('#gamepad .btn_lsb').show();
  } else {
    $('#gamepad .btn_lsb').hide();
  }
  // RSB
  if (btnPressed(gp.buttons[11])) {
    $('#gamepad .btn_rsb').show();
  } else {
    $('#gamepad .btn_rsb').hide();
  }


  // VIEW
  if (btnPressed(gp.buttons[8])) {
    $('#gamepad .btn_view').show();
  } else {
    $('#gamepad .btn_view').hide();
  }
  // MENU
  if (btnPressed(gp.buttons[9])) {
    $('#gamepad .btn_menu').show();
  } else {
    $('#gamepad .btn_menu').hide();
  }


  // 上ボタン
  var cs_u = false;
  if (btnPressed(gp.buttons[12])) {
    cs_u = true;
  } else {
    $('#gamepad .crs_u').hide();
    cs_u = false;
  }
  // 下ボタン
  var cs_d = false;
  if (btnPressed(gp.buttons[13])) {
    cs_d = true;
  } else {
    cs_d = false;
  }
  // 左ボタン
  var cs_l = false;
  if (btnPressed(gp.buttons[14])) {
    cs_l = true;
  } else {
    cs_l = false;
  }
  // 右ボタン
  var cs_r = false;
  if (btnPressed(gp.buttons[15])) {
    cs_r = true;
  } else {
    cs_r = false;
  }

  $('#gamepad .crs_ru').hide();
  $('#gamepad .crs_u').hide();
  $('#gamepad .crs_lu').hide();
  $('#gamepad .crs_r').hide();
  $('#gamepad .crs_rd').hide();
  $('#gamepad .crs_d').hide();
  $('#gamepad .crs_ld').hide();
  $('#gamepad .crs_l').hide();

  if(cs_u) {
    if(cs_r){
      $('#gamepad .crs_ru').show();
    } else if(cs_l){
      $('#gamepad .crs_lu').show();
    } else {
      $('#gamepad .crs_u').show();
    }
  }
  if(cs_r) {
    if(cs_d){
      $('#gamepad .crs_rd').show();
    } else {
      $('#gamepad .crs_r').show();
    }
  }
  if(cs_d) {
    if(cs_l){
      $('#gamepad .crs_ld').show();
    } else {
      $('#gamepad .crs_d').show();
    }
  }
  if(cs_l) {
    if(!cs_u && !cs_d){
      $('#gamepad .crs_l').show();
    }
  }


  // 右スティック左右：2
  var btn_rs_lr = gp.axes[2];
  //左スティック対応
  if (btn_rs_lr <= 0.1 && btn_rs_lr >= -0.1) {
    btn_rs_lr = gp.axes[0];
  }
  var btn_rs_lr_show = false;
  if (btn_rs_lr > 0.1) {
    btn_rs_lr_show = true;
    $('#gamepad .btn_rs').show();
    $('#gamepad .btn_rs').addClass('right');
    $('#gamepad .btn_rs').removeClass('left');

  } else if (btn_rs_lr < -0.1) {
    btn_rs_lr_show = true;
    $('#gamepad .btn_rs').show();
    $('#gamepad .btn_rs').addClass('left');
    $('#gamepad .btn_rs').removeClass('right');

  } else {
    btn_rs_lr_show = false;
    $('#gamepad .btn_rs').removeClass('left');
    $('#gamepad .btn_rs').removeClass('right');

  }
  // 右スティック上下：3
  var btn_rs_ud = gp.axes[3];
  //左スティック対応
  if (btn_rs_ud <= 0.1 && btn_rs_ud >= -0.1) {
    btn_rs_ud = gp.axes[1];
  }
  var btn_rs_ud_show = false;
  if (btn_rs_ud > 0.1) {
    btn_rs_ud_show = true;
    $('#gamepad .btn_rs').show();
    $('#gamepad .btn_rs').addClass('down');
    $('#gamepad .btn_rs').removeClass('up');

  } else if (btn_rs_ud < -0.1) {
    btn_rs_ud_show = true;
    $('#gamepad .btn_rs').show();
    $('#gamepad .btn_rs').addClass('up');
    $('#gamepad .btn_rs').removeClass('down');

  } else {
    btn_rs_ud_show = false;
    $('#gamepad .btn_rs').removeClass('down');
    $('#gamepad .btn_rs').removeClass('up');

  }
  // 非表示
  if(!btn_rs_lr_show && !btn_rs_ud_show){
    $('#gamepad .btn_rs').hide();
  }


  start = requestAnimationFrame(padMonitor);
};



window.addEventListener("gamepadconnected", (e) => {

  if($('#gamepad')[0]){
    $('#gamepad').removeClass('sleep');
  }
  if($('#gamepad .sleepin')[0]){
    $('#gamepad .sleepin').fadeOut(300);
  }

  padMonitor();


  console.log(
    "Gamepad connected at index %d: %s. %d buttons, %d axes.",
    e.gamepad.index,
    e.gamepad.id,
    e.gamepad.buttons.length,
    e.gamepad.axes.length
  );

  
});


